﻿Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms


Public Class mainForm

    Private Opened As Integer

    ' OPNE/CLOSE
    Private Sub btnOpen_Close_Click(sender As Object, e As EventArgs) Handles btnOpen_Close.Click

        Opened = 1
        If (btnOpen_Close.Text = "OPEN") Then
            Try
                Cursor.Current = Cursors.WaitCursor
                ' Device Open and Init
                SerialPort1.PortName = "COM" + (cmbAddress.SelectedIndex + 1).ToString()
                SerialPort1.BaudRate = 9600
                SerialPort1.DataBits = 8
                SerialPort1.StopBits = System.IO.Ports.StopBits.One
                SerialPort1.Parity = System.IO.Ports.Parity.None
                SerialPort1.Handshake = System.IO.Ports.Handshake.None
                SerialPort1.Open()
                SerialPort1.DiscardInBuffer()
                SerialPort1.WriteLine("*cls;:INP OFF;:MODE CC;:INP:MODE LOAD;:MODE:CRAN HIGH;:MODE:VRAN HIGH;:UTIL:LOAD:MODE OFF" + vbLf)
                lblUnit.Text = "A"
                btnLoad.Text = "LOAD ON"

                ' Set form
                btnOpen_Close.Text = "CLOSE"
                btnLoad.Enabled = True
                btnCCmode.Enabled = True
                btnCPmode.Enabled = True
                btnCRmode.Enabled = True
                btnCVmode.Enabled = True
                btnMonitor.Enabled = True
                btnValueSet.Enabled = True
                cmbAddress.Enabled = False

            Catch ex As Exception
                MessageBox.Show(ex.Message)
            Finally
                Cursor.Current = Cursors.Default
            End Try
        Else
            Try
                'Device Close
                SerialPort1.WriteLine(":INP OFF;:UTIL:REM OFF" + vbLf)
                System.Threading.Thread.Sleep(200)
                SerialPort1.Close()

                'Set form
                btnOpen_Close.Text = "OPEN"
                btnLoad.Enabled = False
                btnCCmode.Enabled = False
                btnCPmode.Enabled = False
                btnCRmode.Enabled = False
                btnCVmode.Enabled = False
                btnMonitor.Enabled = False
                btnValueSet.Enabled = False
                cmbAddress.Enabled = True

            Catch ex As Exception
                MessageBox.Show(ex.Message)
            End Try
        End If
    End Sub

    'Form Close(x Button)
    Private Sub mainForm_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        'Device Close
        If (cmbAddress.Enabled = False) Then
            SerialPort1.WriteLine(":INP OFF;:UTIL:REM OFF" + vbLf)
            System.Threading.Thread.Sleep(200)
        End If
        If (Opened <> 0) Then
            SerialPort1.Close()
        End If
    End Sub

    'CC
    Private Sub btnCCmode_Click(sender As Object, e As EventArgs) Handles btnCCmode.Click
        SerialPort1.WriteLine(":MODE CC" + vbLf)
        lblUnit.Text = "A"
    End Sub

    'CP
    Private Sub btnCPmode_Click(sender As Object, e As EventArgs) Handles btnCPmode.Click
        SerialPort1.WriteLine(":MODE CP" + vbLf)
        lblUnit.Text = "W"
    End Sub

    'CR
    Private Sub btnCRmode_Click(sender As Object, e As EventArgs) Handles btnCRmode.Click
        SerialPort1.WriteLine(":MODE CR" + vbLf)
        lblUnit.Text = "mS"
    End Sub

    'CV
    Private Sub btnCVmode_Click(sender As Object, e As EventArgs) Handles btnCVmode.Click
        SerialPort1.WriteLine(":MODE CV" + vbLf)
        lblUnit.Text = "V"
    End Sub

    'Load ON/OFF
    Private Sub btnLoad_Click(sender As Object, e As EventArgs) Handles btnLoad.Click
        If (btnLoad.Text = "LOAD ON") Then
            ' OFF -> ON
            SerialPort1.WriteLine(":INP ON" + vbLf)
            btnLoad.Text = "LOAD OFF"
        Else
            ' ON -> OFF
            SerialPort1.WriteLine(":INP OFF" + vbLf)
            btnLoad.Text = "LOAD ON"
        End If
    End Sub

    ' Set Button
    Private Sub btnValueSet_Click(sender As Object, e As EventArgs) Handles btnValueSet.Click
        Dim SendMsg As String

        If (lblUnit.Text = "A") Then
            SendMsg = ":CURR "
        ElseIf (lblUnit.Text = "W") Then
            SendMsg = ":POW "
        ElseIf (lblUnit.Text = "V") Then
            SendMsg = ":VOLT "
        ElseIf (lblUnit.Text = "mS") Then
            SendMsg = ":RES "
        Else
            SendMsg = ""
        End If

        If (SendMsg <> "") Then
            SendMsg = SendMsg + txtValue.Text + vbLf
            Try
                serialPort1.WriteLine(SendMsg)
            Catch ex As Exception
                MessageBox.Show(ex.Message)
            End Try
        End If
    End Sub

    ' Monitor
    Private Sub btnMonitor_Click(sender As Object, e As EventArgs) Handles btnMonitor.Click
        Dim txtCurrent, txtPower, txtVoltage As String
        Try
            Cursor.Current = Cursors.WaitCursor
            SerialPort1.WriteLine(":MEAS:VOLT?" + vbLf)
            System.Threading.Thread.Sleep(100)
            txtVoltage = SerialPort1.ReadExisting() + "V" + vbCrLf
            SerialPort1.WriteLine(":MEAS:CURR?" + vbLf)
            System.Threading.Thread.Sleep(100)
            txtCurrent = SerialPort1.ReadExisting() + "A" + vbCrLf
            SerialPort1.WriteLine(":MEAS:POW?" + vbLf)
            System.Threading.Thread.Sleep(100)
            txtPower = SerialPort1.ReadExisting() + "W" + vbCrLf
            txtMeasure.Text = txtCurrent + txtVoltage + txtPower
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        Finally
            Cursor.Current = Cursors.Default
        End Try
    End Sub

    'Load
    Private Sub mainForm_Load(sender As Object, e As EventArgs) Handles Me.Load
        Dim i As Integer
        Opened = 0
        For i = 1 To 29
            cmbAddress.Items.Add(i)
        Next i
        cmbAddress.SelectedIndex = 0

        ' Set form
        btnOpen_Close.Text = "OPEN"
        btnLoad.Enabled = False
        btnCCmode.Enabled = False
        btnCPmode.Enabled = False
        btnCRmode.Enabled = False
        btnCVmode.Enabled = False
        btnMonitor.Enabled = False
        btnValueSet.Enabled = False
        cmbAddress.Enabled = True
    End Sub
End Class
